<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateApplicationUserCapfProfileReq StructType
 * @subpackage Structs
 */
class UpdateApplicationUserCapfProfileReq extends APIRequest
{
    /**
     * The instanceId
     * Meta information extracted from the WSDL
     * - choice: uuid | instanceId
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $instanceId;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | instanceId
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The certificateOperation
     * Meta information extracted from the WSDL
     * - default: No Pending Operation
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $certificateOperation;
    /**
     * The authenticationMode
     * Meta information extracted from the WSDL
     * - documentation: Read Only when certificateOperation is 'No Pending Operation'
     * - default: By Null String
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $authenticationMode;
    /**
     * The authenticationString
     * Meta information extracted from the WSDL
     * - documentation: Read Only when certificateOperation is 'No Pending Operation'
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $authenticationString;
    /**
     * The keySize
     * Meta information extracted from the WSDL
     * - documentation: Read Only when certificateOperation is 'No Pending Operation'
     * - default: 1024
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $keySize;
    /**
     * The operationCompletion
     * Meta information extracted from the WSDL
     * - documentation: Required format is YYYY:MM:DD:HH:SS. Read Only when certificateOperation is 'No Pending Operation'. Please provide the above format while adding a new device
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $operationCompletion;
    /**
     * Constructor method for UpdateApplicationUserCapfProfileReq
     * @uses UpdateApplicationUserCapfProfileReq::setInstanceId()
     * @uses UpdateApplicationUserCapfProfileReq::setUuid()
     * @uses UpdateApplicationUserCapfProfileReq::setCertificateOperation()
     * @uses UpdateApplicationUserCapfProfileReq::setAuthenticationMode()
     * @uses UpdateApplicationUserCapfProfileReq::setAuthenticationString()
     * @uses UpdateApplicationUserCapfProfileReq::setKeySize()
     * @uses UpdateApplicationUserCapfProfileReq::setOperationCompletion()
     * @param string $instanceId
     * @param string $uuid
     * @param string $certificateOperation
     * @param string $authenticationMode
     * @param string $authenticationString
     * @param string $keySize
     * @param string $operationCompletion
     */
    public function __construct($instanceId = null, $uuid = null, $certificateOperation = 'No Pending Operation', $authenticationMode = 'By Null String', $authenticationString = null, $keySize = '1024', $operationCompletion = null)
    {
        $this
            ->setInstanceId($instanceId)
            ->setUuid($uuid)
            ->setCertificateOperation($certificateOperation)
            ->setAuthenticationMode($authenticationMode)
            ->setAuthenticationString($authenticationString)
            ->setKeySize($keySize)
            ->setOperationCompletion($operationCompletion);
    }
    /**
     * Get instanceId value
     * @return string
     */
    public function getInstanceId()
    {
        return isset($this->instanceId) ? $this->instanceId : null;
    }
    /**
     * Set instanceId value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $instanceId
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setInstanceId($instanceId = null)
    {
        if (is_null($instanceId) || (is_array($instanceId) && empty($instanceId))) {
            unset($this->instanceId);
        } else {
            $this->instanceId = $instanceId;
        }
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setUuid($uuid = null)
    {
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get certificateOperation value
     * @return string|null
     */
    public function getCertificateOperation()
    {
        return $this->certificateOperation;
    }
    /**
     * Set certificateOperation value
     * @param string $certificateOperation
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setCertificateOperation($certificateOperation = 'No Pending Operation')
    {
        $this->certificateOperation = $certificateOperation;
        return $this;
    }
    /**
     * Get authenticationMode value
     * @return string|null
     */
    public function getAuthenticationMode()
    {
        return $this->authenticationMode;
    }
    /**
     * Set authenticationMode value
     * @param string $authenticationMode
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setAuthenticationMode($authenticationMode = 'By Null String')
    {
        $this->authenticationMode = $authenticationMode;
        return $this;
    }
    /**
     * Get authenticationString value
     * @return string|null
     */
    public function getAuthenticationString()
    {
        return $this->authenticationString;
    }
    /**
     * Set authenticationString value
     * @param string $authenticationString
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setAuthenticationString($authenticationString = null)
    {
        $this->authenticationString = $authenticationString;
        return $this;
    }
    /**
     * Get keySize value
     * @return string|null
     */
    public function getKeySize()
    {
        return $this->keySize;
    }
    /**
     * Set keySize value
     * @param string $keySize
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setKeySize($keySize = '1024')
    {
        $this->keySize = $keySize;
        return $this;
    }
    /**
     * Get operationCompletion value
     * @return string|null
     */
    public function getOperationCompletion()
    {
        return $this->operationCompletion;
    }
    /**
     * Set operationCompletion value
     * @param string $operationCompletion
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq
     */
    public function setOperationCompletion($operationCompletion = null)
    {
        $this->operationCompletion = $operationCompletion;
        return $this;
    }
}
